#ifndef _Thread_local
#define _Thread_local

#include <mutex> // 'std::mutex'...
#include <string>

class Illustration_of_thread_local {
	/** The game is, as much as possible, avoiding the following inconsistent compositions:
	 * "FrançoisSarkozy" and "NicolasHollande" */
	 // Threads using '_Francois' have their own copy (read-only mode):
	static thread_local const std::string _Francois;
	static thread_local const std::string _Hollande;
	static thread_local const std::string _Nicolas;
	static thread_local const std::string _Sarkozy;
	static std::string _Patronym;

	static bool _Checkable;
	static bool _Stop;

	static std::mutex _Mutex; // Create critical section for string manipulation ('#include <mutex>')...

	static void _Check();
	static void _Set(std::string const&, std::string const&);
	static void _Set_Francois_Hollande();
	static void _Set_Nicolas_Sarkozy();
public:
	static int Bads;
	static int Goods;
	static void Go();
};

#endif